/*****************************************************
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,600000 MHz
*****************************************************/

#include <tiny13a.h>

#define s_step 376

//#define Rb_upr 27000 //Ohms
//#define Rb_lwr 2000   //Ohms
//#define Ub_max_adc ((110*(Rb_upr+Rb_lwr))/Rb_lwr) //=U_max*100, 15,95V*100
//#define Rhv_upr 510000 //Ohms
//#define Rhv_lwr 1500   //Ohms  
//#define UHV_max_adc ((110*(Rhv_upr+Rhv_lwr))/Rhv_lwr) //=U_max*100, 375,1V*100

unsigned char tmr0,tmr1,ADC1,ADC2;
bit hvcnt;
flash unsigned char s_table [s_step/2]=
{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,21,
22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,
43,44,45,46,47,48,49,50,51,52,53,54,55,56,56,57,58,59,60,61,62,
63,64,65,66,67,67,68,69,70,71,72,73,74,74,75,76,77,78,79,79,80,
81,82,83,83,84,85,86,87,87,88,89,90,90,91,92,92,93,94,95,95,96,
97,97,98,99,99,100,100,101,102,102,103,104,104,105,105,106,106,107,108,108,109,
109,110,110,111,111,112,112,113,113,114,114,114,115,115,116,116,116,117,117,118,118,
118,119,119,119,120,120,120,121,121,121,121,122,122,122,122,123,123,123,123,123,124,
124,124,124,124,124,125,125,125,125,125,125,125,125,125,125,125,125,125,125,125};

void t0_cfg()
{
 TCCR0A=0;
 TCCR0A|=1<<COM0A1|1<<COM0A0|1<<COM0B1|1<<WGM01|1<<WGM00;
 TCCR0B=OCR0A=OCR0B=1;
 TIMSK0|=1<<OCIE0A;
}
void ports_cfg()
{
 PORTB=0b11101000;
 DDRB =0b11100011;
}
void adc_cfg()
{
 ADMUX|=1<<REFS0|1<<ADLAR|1;
 ADCSRA|=1<<ADEN|1<<ADSC|7;   
}
void hv_cnt()
{
 if(!hvcnt)
 {
 if(ADC2<150){if(tmr0)tmr0--;} 
 else if(ADC2>170){if(tmr0<100)tmr0++;}
 } 
}
void adc_scan()
{
 static unsigned int ADC1_tmp, ADC2_tmp; 
 static unsigned char i, ii;
  
if(!ADCSRA.ADSC)
{    
  if (ADMUX&1)
 {
  ADMUX &= 0b11110000; ADMUX |= 2;  
  if (i<8) {ADC1_tmp += ADCH; i++;} 
    else {ADC1=ADC1_tmp/8; ADC1_tmp=i=0;} 
  ADCSRA |= 1<<ADSC; 
 }  
   else
 {
  ADMUX &= 0b11110000; ADMUX |= 1;  
  if (ii<16) {ADC2_tmp += ADCH; ii++;} 
    else {ADC2=ADC2_tmp/16; ADC2_tmp=ii=0;hv_cnt();} 
  ADCSRA |= 1<<ADSC; 
 }
}
}
void bat_detect()
{
 //unsigned char tmp;  
 //tmp=((unsigned long)ADC1*Ub_max_adc/(0xff*10)); 
 
 if(ADC1>170){tmr1=250;hvcnt=0;}   
 else if ((ADC1<145)||(!tmr1)){tmr0=125;hvcnt=1;}
}
void exiti_cfg()
{
 GIMSK|=1<<PCIE;
 PCMSK|=1<<PCINT3;   
}

interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
 static unsigned char c=0;
 static bit d=1,p=1;
  

 if((d)&&(p))                                          
 {
  if(tmr0){if(tmr0<s_table [c]){OCR0A=OCR0B=0x7f+s_table [c]-tmr0;}else{OCR0A=OCR0B=0x7f;}}
  else {OCR0A=OCR0B=0x7f+s_table [c];}
  if(c<s_step/2-1){c++;} else {d=0;}
 } 
    else if((!d)&&(p))
    {
     if(tmr0){if(tmr0<s_table [c]){OCR0A=OCR0B=0x7f+s_table [c]-tmr0;}else{OCR0A=OCR0B=0x7f;}}
     else {OCR0A=OCR0B=0x7f+s_table [c];}
     if(c){c--;} else {d=1;p=0;}
    }
        else if((d)&&(!p)) 
        {
         if(tmr0){if(tmr0<s_table [c]){OCR0A=OCR0B=0x7f-s_table [c]+tmr0;}else{OCR0A=OCR0B=0x7f;}}
         else{OCR0A=OCR0B=0x7f-s_table[c];}
         if(c<s_step/2-1){c++;} else {d=0;if(tmr1){tmr1--;}}
        }
            else
            {
             if(tmr0){if(tmr0<s_table [c]){OCR0A=OCR0B=0x7f-s_table [c]+tmr0;}else{OCR0A=OCR0B=0x7f;}}
             else{OCR0A=OCR0B=0x7f-s_table[c];}
             if(c){c--;}else {d=1;p=1;}
            }  
   
}            
interrupt [PC_INT0] void pin_change_isr(void)
{
 if(!PINB.3){tmr0=125;}
}

void main(void)
{
ports_cfg();
adc_cfg();
exiti_cfg();
t0_cfg();

tmr0=125;

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Watchdog Timer Prescaler: OSC/2k
#pragma optsize-
WDTCR=0x18;
WDTCR=0x08;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")

while (1)
      {
       adc_scan();
       bat_detect();
       
       #asm("wdr")
      }
}
